/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUMOTC_MOTIVOCANC                                           */
/* Tabela : MOTIVOCANC                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 26/02/2006 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATUMOTC_MOTIVOCANC
BEFORE INSERT OR UPDATE OR DELETE
ON MOTIVOCANC FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMOTC := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDMOTICANC,0) <> NVL(:NEW.CDMOTICANC,0)) OR
         (NVL(:OLD.DSMOTICANC,0) <> NVL(:NEW.DSMOTICANC,0)) THEN
         :NEW.DTULTATUMOTC := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MOTIVOCANC', '', 'CDMOTICANC='||:OLD.CDMOTICANC||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MOTIVOCANC MODIFY DTULTATUMOTC DEFAULT SYSDATE
/



-- VERSAO --
BEGIN ATUVEROBJ('DTULTATUMOTC_MOTIVOCANC','4.11.072'); END;
/

